diff --git a/base/deploy/src/scriptlets/war_explosion.py b/base/deploy/src/scriptlets/war_explosion.py
new file mode 100644
index 0000000..4f235d8
--- /dev/null
+++ b/base/deploy/src/scriptlets/war_explosion.py
@@ -0,0 +1,69 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            config.pki_log.info(log.WAR_EXPLOSION_SPAWN_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
+            # deploy war file
+            util.directory.create(master['pki_webapps_subsystem_path'])
+            util.war.explode(master['pki_war'],
+                             master['pki_webapps_subsystem_path'])
+            # establish convenience symbolic links
+            util.symlink.create(master['pki_webapps_webinf_classes_path'],
+                master['pki_webapps_subsystem_webinf_classes_link'])
+            util.symlink.create(master['pki_webapps_webinf_lib_path'],
+                master['pki_webapps_subsystem_webinf_lib_link'])
+            # set ownerships, permissions, and acls
+            util.directory.set_mode(master['pki_webapps_subsystem_path'])
+        return self.rv
+
+    def respawn(self):
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            config.pki_log.info(log.WAR_EXPLOSION_RESPAWN_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
+            # redeploy war file
+            util.directory.modify(master['pki_webapps_subsystem_path'])
+            util.war.explode(master['pki_war'],
+                             master['pki_webapps_subsystem_path'])
+            # update ownerships, permissions, and acls
+            # NOTE:  This includes existing convenience symbolic links
+            util.directory.set_mode(master['pki_webapps_subsystem_path'])
+        return self.rv
+
+    def destroy(self):
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            config.pki_log.info(log.WAR_EXPLOSION_DESTROY_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
+            util.directory.delete(master['pki_webapps_subsystem_path'])
+        return self.rv
diff --git a/base/deploy/src/scriptlets/webserver_layout.py b/base/deploy/src/scriptlets/webserver_layout.py
new file mode 100644
index 0000000..9b3deb7
--- /dev/null
+++ b/base/deploy/src/scriptlets/webserver_layout.py
@@ -0,0 +1,119 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.WEBSERVER_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish instance-based webserver base
+        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            util.directory.create(master['pki_apache_path'])
+        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.directory.create(master['pki_tomcat_path'])
+            util.directory.create(master['pki_common_path'])
+            util.directory.create(master['pki_common_lib_path'])
+            util.directory.create(master['pki_conf_path'])
+            util.directory.create(master['pki_webapps_path'])
+            util.directory.create(master['pki_webapps_root_path'])
+            util.directory.create(master['pki_webapps_root_webinf_path'])
+            util.directory.create(master['pki_webapps_webinf_path'])
+            util.directory.create(master['pki_webapps_webinf_classes_path'])
+            util.directory.create(master['pki_webapps_webinf_lib_path'])
+        # establish instance-based webserver configuration
+        util.directory.create(master['pki_database_path'])
+        # establish convenience symbolic links
+        util.symlink.create(master['pki_database_path'],
+                            master['pki_instance_database_link'])
+        util.symlink.create(master['pki_tomcat_bin_path'],
+                            master['pki_tomcat_bin_link'])
+        util.symlink.create(master['pki_tomcat_lib_path'],
+                            master['pki_tomcat_lib_link'])
+        util.symlink.create(master['pki_instance_log_path'],
+                            master['pki_tomcat_logs_link'])
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.WEBSERVER_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # update instance-based webserver base
+        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            util.directory.modify(master['pki_apache_path'])
+        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.directory.modify(master['pki_tomcat_path'])
+            util.directory.modify(master['pki_common_path'])
+            util.directory.modify(master['pki_common_lib_path'])
+            util.directory.modify(master['pki_conf_path'])
+            util.directory.modify(master['pki_webapps_path'])
+            util.directory.modify(master['pki_webapps_root_path'])
+            util.directory.modify(master['pki_webapps_root_webinf_path'])
+            util.directory.modify(master['pki_webapps_webinf_path'])
+            util.directory.modify(master['pki_webapps_webinf_classes_path'])
+            util.directory.modify(master['pki_webapps_webinf_lib_path'])
+        # update instance-based webserver configuration
+        util.directory.modify(master['pki_database_path'])
+        # update convenience symbolic links
+        util.symlink.modify(master['pki_instance_database_link'])
+        util.symlink.modify(master['pki_tomcat_bin_link'])
+        util.symlink.modify(master['pki_tomcat_lib_link'])
+        util.symlink.modify(master['pki_tomcat_logs_link'])
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.WEBSERVER_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # remove instance-based webserver base
+        if not config.pki_dry_run_flag and\
+           master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+           util.instance.apache_instances(master['pki_instance_path']) == 0:
+            util.directory.delete(master['pki_apache_path'])
+        elif master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS and\
+             util.instance.apache_instances(master['pki_instance_path']) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(master['pki_apache_path'])
+        if not config.pki_dry_run_flag and\
+           master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+           util.instance.tomcat_instances(master['pki_instance_path']) == 0:
+            util.directory.delete(master['pki_tomcat_path'])
+        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
+             util.instance.tomcat_instances(master['pki_instance_path']) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(master['pki_tomcat_path'])
+        # remove instance-based webserver configuration
+        if not config.pki_dry_run_flag and\
+           util.instance.pki_subsystem_instances(\
+               master['pki_instance_path']) == 0:
+            util.directory.delete(master['pki_database_path'])
+        elif util.instance.pki_subsystem_instances(\
+            master['pki_instance_path']) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(master['pki_database_path'])
+        return self.rv
diff --git a/scripts/build_dogtag_pki b/scripts/build_dogtag_pki
index f2c171f..6f44dd7 100755
--- a/scripts/build_dogtag_pki
+++ b/scripts/build_dogtag_pki
@@ -127,6 +127,7 @@ PKI_TPS_THEME=${PKI_FLAVOR}-pki-tps-theme${RPM_EXT}
 PKI_CONSOLE_THEME=${PKI_FLAVOR}-pki-console-theme${RPM_EXT}
 
 # Establish PKI core package names
+PKI_DEPLOY=pki-deploy${RPM_EXT}
 PKI_SETUP=pki-setup${RPM_EXT}
 PKI_SYMKEY=pki-symkey${RPM_EXT}
 PKI_NATIVE_TOOLS=pki-native-tools${RPM_EXT}
@@ -175,7 +176,7 @@ cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}
 mkdir -p ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cp -p ${NOARCH}/*.rpm ${PKI_ARCH}/*.rpm ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
-${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SETUP} ${PKI_SYMKEY} ${PKI_NATIVE_TOOLS} ${PKI_UTIL} ${PKI_UTIL_JAVADOC} ${PKI_JAVA_TOOLS} ${PKI_JAVA_TOOLS_JAVADOC} ${PKI_COMMON} ${PKI_COMMON_JAVADOC} ${PKI_SELINUX} ${PKI_CA} ${PKI_SILENT}
+${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_DEPLOY} ${PKI_SETUP} ${PKI_SYMKEY} ${PKI_NATIVE_TOOLS} ${PKI_UTIL} ${PKI_UTIL_JAVADOC} ${PKI_JAVA_TOOLS} ${PKI_JAVA_TOOLS_JAVADOC} ${PKI_COMMON} ${PKI_COMMON_JAVADOC} ${PKI_SELINUX} ${PKI_CA} ${PKI_KRA} ${PKI_OCSP} ${PKI_TKS} ${PKI_SILENT}
 
 # Compose and install 'pki-ra' packages
 cd ${PKI_PWD}
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 837557d..a38b904 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -63,6 +63,12 @@ BuildRequires:    jss >= 4.2.6-17
 BuildRequires:    tomcatjss >= 2.0.0
 %endif
 %endif
+# Add the following build-time requirements to support the "pki-deploy" package
+BuildRequires:    pki-common-theme
+BuildRequires:    pki-ca-theme
+BuildRequires:    pki-kra-theme
+BuildRequires:    pki-ocsp-theme
+BuildRequires:    pki-tks-theme
 
 Source0:          http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}%{?prerel}.tar.gz
 
@@ -761,8 +767,8 @@ echo "D /var/run/pki/tks 0755 root root -"  >> %{buildroot}%{_sysconfdir}/tmpfil
 %{__rm} %{buildroot}%{_initrddir}/pki-ocspd
 %{__rm} %{buildroot}%{_initrddir}/pki-tksd
 # Create symlink to the pki-jndi-realm jar
-mkdir -p %{buildroot}%{_javadir}/tomcat6
-ln -s -f %{_javadir}/pki/pki-jndi-realm.jar %{buildroot}%{_javadir}/tomcat6/pki-jndi-realm.jar
+%{__mkdir_p} %{buildroot}%{_javadir}/tomcat6
+%{__ln_s} -f %{_javadir}/pki/pki-jndi-realm.jar %{buildroot}%{_javadir}/tomcat6/pki-jndi-realm.jar
 %else
 %{__rm} %{buildroot}%{_bindir}/pkicontrol
 %{__rm} -rf %{buildroot}%{_sysconfdir}/systemd/system/pki-cad.target.wants
@@ -786,6 +792,21 @@ if [ -d /etc/sysconfig/pki/%i ]; then                                        \
 fi                                                                           \
 )
 
+# Create PKI subsystem "war" files
+for subsystem in ca kra ocsp tks; do
+    echo "Constructing '${subsystem}.war' . . ."
+    %{__mkdir_p} %{buildroot}%{_datadir}/pki/${subsystem}/war
+    %{__cp} -r %{_datadir}/pki/common-ui/admin %{buildroot}%{_datadir}/pki/${subsystem}/war
+    %{__cp} -r %{_datadir}/pki/common-ui/css %{buildroot}%{_datadir}/pki/${subsystem}/war
+    %{__cp} -r %{_datadir}/pki/common-ui/img %{buildroot}%{_datadir}/pki/${subsystem}/war
+    %{__cp} -r %{_datadir}/pki/${subsystem}-ui/webapps/${subsystem}/* %{buildroot}%{_datadir}/pki/${subsystem}/war
+    %{__cp} -r %{buildroot}%{_datadir}/pki/${subsystem}/webapps/${subsystem}/WEB-INF %{buildroot}%{_datadir}/pki/${subsystem}/war
+    cd %{buildroot}%{_datadir}/pki/${subsystem}/war
+    jar -cvMf ../${subsystem}.war *
+    %{__rm} -rf %{buildroot}%{_datadir}/pki/${subsystem}/war/*
+    %{__mv} ../${subsystem}.war %{buildroot}%{_datadir}/pki/${subsystem}/war
+done
+
 %pre -n pki-selinux
 %saveFileContext targeted
 
@@ -1216,8 +1237,9 @@ fi
 %{_datadir}/pki/ca/emails/
 %dir %{_datadir}/pki/ca/profiles
 %{_datadir}/pki/ca/profiles/ca/
-%{_datadir}/pki/ca/webapps/
 %{_datadir}/pki/ca/setup/
+%{_datadir}/pki/ca/war/
+%{_datadir}/pki/ca/webapps/
 %dir %{_localstatedir}/lock/pki/ca
 %dir %{_localstatedir}/run/pki/ca
 %if 0%{?fedora} >= 15
@@ -1245,6 +1267,7 @@ fi
 %dir %{_datadir}/pki/kra
 %{_datadir}/pki/kra/conf/
 %{_datadir}/pki/kra/setup/
+%{_datadir}/pki/kra/war/
 %{_datadir}/pki/kra/webapps/
 %dir %{_localstatedir}/lock/pki/kra
 %dir %{_localstatedir}/run/pki/kra
@@ -1273,6 +1296,7 @@ fi
 %dir %{_datadir}/pki/ocsp
 %{_datadir}/pki/ocsp/conf/
 %{_datadir}/pki/ocsp/setup/
+%{_datadir}/pki/ocsp/war/
 %{_datadir}/pki/ocsp/webapps/
 %dir %{_localstatedir}/lock/pki/ocsp
 %dir %{_localstatedir}/run/pki/ocsp
@@ -1301,6 +1325,7 @@ fi
 %dir %{_datadir}/pki/tks
 %{_datadir}/pki/tks/conf/
 %{_datadir}/pki/tks/setup/
+%{_datadir}/pki/tks/war/
 %{_datadir}/pki/tks/webapps/
 %dir %{_localstatedir}/lock/pki/tks
 %dir %{_localstatedir}/run/pki/tks
-- 
1.7.7.6

